<?php
header('Access-Control-Allow-Origin: *');
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/formula.model.php';
require_once 'model/formula.entidad.php';
require_once 'model/formuladetalle.model.php';
require_once 'model/formuladetalle.entidad.php';
class FormulaController
{
    private $parametro_model;
    private $prodserv_model;
    private $formula_model;
    private $formuladetalle_model;
    private $segurdidad;
    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->prodserv_model = new ProdservModel();
        $this->formula_model = new FormulaModel();
        $this->formuladetalle_model = new FormulaDetalleModel();
        $this->seguridad = new Seguridad();
    }

    public function Index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $formulas = $this->formula_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfaformula.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
    public function FrmGuardarFormula()

    {
        $productos = $this->prodserv_model->Listar();

        require_once 'view/webforms/wfaformulaa.php';
    }
    public function GuardarFormula()
    {
        $detalle_for = json_decode($_POST['detalle']);

        $for = new formula();
        if ($_POST['formula_Id'] != 0 ? $for->__SET('formula_Id', $_POST['formula_Id']) : '');

        $for->__SET('sForNombre', $_POST['sForNombre']);
        $for->__SET('dForFecha', $_POST['dForFecha']);
        $for->__SET('nForProdResultante', $_POST['nForProdResultante']);
        $for->__SET('sForDescripcion', $_POST['sForDescripcion']);
        $for->__SET('nForEstado', $_POST['nForEstado']);
        $for->__SET('nForEliminado', 0);
        $for->__SET('nForUsuario_Id', $_SESSION['usu_codigo']);

        if ($_POST['formula_Id'] != 0) {
            $this->formula_model->Editar($for);
        } else {
            $formula = $this->formula_model->Crear($for);
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                    </div>';
        }

        $detalle_for_cantidad = count($detalle_for);
        $grabado = [];

        $formula_detalle_antes = json_decode($_POST['j_detalle_for_filtrado']);

        //Eliminar detalle de formula que no se encuentran en el detalle de formula actual
        if (count($formula_detalle_antes) > 0) {
            for ($i = 0; $i < count($formula_detalle_antes); $i++) {
                $this->formuladetalle_model->EliminarProductoDetalleFormula($formula_detalle_antes[$i]->idDetFor);
            }
        }

        for ($i = 0; $i < $detalle_for_cantidad; $i++) {

            $fordet = new formuladetalle();
            if ($detalle_for[$i]->idDetFor != 0 ? $for->__SET('formuladetalle_Id', $detalle_for[$i]->idDetFor) : '');
            $fordet->__SET('formula_Id', isset($formula) ? $formula : $_POST['formula_Id']);
            $fordet->__SET('nForDetProducto', $detalle_for[$i]->nForDetProducto);
            $fordet->__SET('nForDetCantidad', $detalle_for[$i]->nForDetCantidad);
            $fordet->__SET('nForDetUM_Id', $detalle_for[$i]->nForDetUM_Id);
            if ($detalle_for[$i]->idDetFor != 0) {
                $this->formuladetalle_model->EditarDetalleFormula($fordet);
            } else {
                $this->formuladetalle_model->GuadarDetalleFormula2($fordet);
                $grabado[] = true;
            }
        }
    }
    public function FrmEditarFormula()
    {
        $datos = $this->formula_model->Buscar($_POST['formula_Id']);
        $productos = $this->prodserv_model->Listar();
        $lista_detalle_for = $this->formuladetalle_model->ListarDetalle($_POST['formula_Id']);

        for ($i = 0; $i < count($lista_detalle_for); $i++) {
            $medida = isset($lista_detalle_for[$i]->nForDetUM_Id) ? $this->formuladetalle_model->ObtenerMedidaXId($lista_detalle_for[$i]->nForDetUM_Id)->sUndAlias : '';
            $lista_detalle_for[$i]->MedidaNuevaAgregada = $medida;
        }

        foreach ($datos as $r) :
            require_once 'view/webforms/wfaformulaa.php';
        endforeach;
    }
    public function mostrarFormula()
    {
        $datos = $this->formula_model->Buscar($_POST['formula_Id']);
        $data = array();
        foreach ($datos as $r) :
            echo "<tr>";
            echo "<td>Nombre fórmula: </td>";
            echo "<td>" . $r->__GET('sForNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Fecha: </td>";
            echo "<td>" . $r->__GET('dForFecha') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Producto resultante: </td>";
            echo "<td>" . $r->__GET('sProSrvNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Decripción:</td>";
            echo "<td>"  . $r->__GET('sForDescripcion') . " </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Estado</td>";
            echo "<td>" . ($r->__GET('nForEstado') == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label bg-danger">Inhabilitado</span>') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Unidad de Medida</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_formula = $this->formuladetalle_model->ListarDetalle($_POST['formula_Id']);
            foreach ($detalle_formula as $detmov) :
                $medida = isset($detmov->nForDetUM_Id) ? $this->formuladetalle_model->ObtenerMedidaXId($detmov->nForDetUM_Id) : '';
                echo '<tr>';
                echo '<td>' . $detmov->sProSrvNombre . '</td>';
                echo '<td>' . $detmov->nForDetCantidad . '</td>';
                echo '<td>' . $medida->sUndAlias . '</td>';
            endforeach;
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }
    public function EliminarFormula()
    {
        $for = new formula();
        $for->__SET('formula_Id', $_POST['IdFor']);
        $this->formula_model->Eliminar($for);
        echo '<script type="text/javascript">window.location="?c=Formula&a=Index";</script>';
    }
}
