<?php

require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/guiaremision.model.php';
require_once 'model/guiaremision.entidad.php';
require_once 'model/guiaremisiondetalle.model.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/motivotraslado.model.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/tipotransporte.model.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/vendedor.model.php';
require_once 'model/vendedor.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'controller/electronic.controller.php';
require_once './extends/request-services.php';
require_once 'model/origendestinodirecciones.model.php';
require_once 'model/origendestinodirecciones.entidad.php';


class GuiaremisionController
{
    private $parametro_model;
    private $guiaremision_model;
    private $guiaremisiondetalle_model;
    private $almacen_model;
    private $motivotraslado_model;
    private $documento_model;
    private $electronic_controller;
    public $vendedor_model;
    private $tipotransporte_model;
    private $unidadmedida_model;
    public $tipomovimiento_model;
    private $movimiento_model;
    public $movimientodetalle_model;
    private $origendestino_direcciones_model;
    public $prodserv_model;
    private $seguridad;
    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->guiaremision_model = new GuiaremisionModel();
        $this->guiaremisiondetalle_model = new GuiaremisiondetalleModel();
        $this->almacen_model = new AlmacenModel();
        $this->motivotraslado_model = new MotivotrasladoModel();
        $this->documento_model = new DocumentoModel();
        $this->electronic_controller = new ElectronicController();
        $this->tipotransporte_model = new TipotransporteModel();
        $this->prodserv_model = new ProdservModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->vendedor_model = new VendedorModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->origendestino_direcciones_model = new OrigendestinoDireccionesModel();
        $this->movimiento_model = new MovimientoModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->seguridad = new Seguridad();
    }

    public function index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $guiaremision = $this->guiaremision_model->Guia_listardate($fechaIni, $fechaFin);

        // $guiaremision = $this->guiaremision_model->Guia_listardate(
        //     isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
        //     isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))));
        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremision.php';
        if (isset($_POST['Movimiento_Id'])) {
            echo "<script type='text/javascript'>
                    $(document).ready(function (){
                        PromoverMovimientoGR({$_POST['Movimiento_Id']})
                    });
                </script>";
        } else {

            echo "<script type='text/javascript'>
                            $(document).ready(function (){
                                $('.operaciones').addClass('active');
                            });
                      </script>";
        }
        require_once 'view/footer.php';
    }

    public function formulario()
    {
        $almacen = $this->almacen_model->Listar();
        $parametro = $this->parametro_model->ListarParametros();
        $motivotraslado = $this->motivotraslado_model->Listar();
        $tipotransporte = $this->tipotransporte_model->Listar();

        $unidadmedida = $this->unidadmedida_model->Listar();

        $transportistas = $this->guiaremision_model->TransportistaListar();

        $guias = $this->documento_model->ListarGuias();

        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisiona.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function save()
    {

        try {
            if ($_REQUEST['Guiaremision_Id'] == 0) {

                $id = $this->guiaremision_model->Crear($_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $detalle_creado = $this->guiaremisiondetalle_model->Crear([
                            'Guiaremision_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                        //print_r('detalle creado:'.(bool)$detalle_creado);
                    }
                }
                $this->documento_model->Incrementa(12);
            } else {

                $id = $_REQUEST['Guiaremision_Id'];
                $this->guiaremision_model->Update($_REQUEST['Guiaremision_Id'], $_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    $this->guiaremisiondetalle_model->Delete($_REQUEST['Guiaremision_Id']);
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $this->guiaremisiondetalle_model->Crear([
                            'Guiaremision_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                    }
                }
            }
            echo $id;
        } catch (Exception $e) {
            var_dump($e);
        }
    }

    public function Previsualizar()
    {

        $parametro = $this->parametro_model->ListarParametros();
        $guiaremision = $this->guiaremision_model->Buscar($_REQUEST['code']);
        $gr_format = explode("-", $guiaremision['sSerieNumeroRelacionado']);

        //obtenemos el id del documento del comprobante relacionado
        $id = 0;
        $get_id_doc = $this->documento_model->BuscarByNombreCorto($gr_format[0]);
        foreach ($get_id_doc as $t) {
            $id = $t->__GET('Documento_Id');
        }


        $button_gr = '';

        if (count($gr_format) > 1) {
            //obtenemos el id del comprobante relacionado
            $getid_comprobante = $this->movimiento_model->ObtenerIdConNroSerie($id, $gr_format[1]);
            $id_comprobante = $getid_comprobante[0]->Movimiento_Id;
            // verificamos si factura está validada

            $request = new RequestServices();
            $request->url = 'http://colibri2.fmsac.com/comprobante/' . $_SESSION['usu_enterpriseRuc'] . '/' . $gr_format[0] . '/' . $gr_format[1];
            $request->parameters = [];
            $result = $request->serviceGET();


            // si está validada habilitados el botón
            if ($result == 1 || $result == 2 || $result == 3) {

                $button_gr = '<button type="submit" class="btn btn-primary btn-flat">Enviar GR</button>';
            } else {
                $button_gr = '<button type="button" id="comprobante_gr" data-toggle="modal" data-target="#modal-confirmar-validacion" class="btn btn-primary btn-flat" data-gr="' . $_REQUEST['code'] . '" data-comprobante="' . $id_comprobante . '">Enviar GR + Comprobante</button>';
            }
        }
        // echo '<pre>';
        // var_dump($gr_format); //[{[0]=>NV, [1]=>9}]
        // echo '</pre>';
        // exit;


        // echo '<pre>';
        // var_dump($id_comprobante, $getid_comprobante); //100 y [{Movimiento_Id: 100,]
        // echo '</pre>';
        // exit;


        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisionv.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function eliminar()
    {
        $this->guiaremision_model->Eliminar($_REQUEST['guiaremision_id']);
    }

    public function Enviarcomprobante()
    {
        echo $this->electronic_controller->GuiaRemision($_REQUEST['Guiaremision_Id']);
    }

    public function Buscar()
    {
        $guiasremision = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        $guiasremision['dTraFecha'] = date('d-m-Y', strtotime($guiasremision['dTraFecha']));
        $guiasremision['dTraFechaTraslado'] = date('d-m-Y', strtotime($guiasremision['dTraFechaTraslado']));
        $guiasremision['detalle'] = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        echo json_encode($guiasremision);
    }

    public function comprobante()
    {
        $guia = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($guia);
        $detalle = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($detalle);

        $toPrint = sprintf(
            '%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '09',
            $guia['sTraSerie'],
            $guia['sTraNumero'],
            '0.00', //$r->nMovIGV,
            '0.00', //$r->nMovTotal,
            date('d-m-Y', strtotime($guia['dTraFecha'])),
            (strlen($guia['sCliNroIdentidad'] == 8) ? '1' : '6'), //DNI=1;6=RUC
            $guia['sCliNroIdentidad'],
            ''
        );

        require_once 'view/webforms/PDF/guiaremision2.php';
    }

    public function PromoverMovimientoGR()
    {

        $parametro = $this->parametro_model->ListarParametros();
        $almacen = $this->almacen_model->Listar();
        // $documentos = $this->documento_model->Listar();
        $tipomovimiento = $this->tipomovimiento_model->Listar();
        $vendedor = $this->vendedor_model->Listar();
        $productos = $this->prodserv_model->Listar();
        $obtenerRol = $this->seguridad->roles(); // jc- 2021-12-16
        $RolVendedor = $obtenerRol[0]->RoleName; // jc- 2021-12-16
        $detracciones = $this->movimiento_model->ListarDetracciones();
        $habilitado = 0;
        $motivotraslado = $this->motivotraslado_model->Listar();
        $tipotransporte = $this->tipotransporte_model->Listar();

        $transportistas = $this->guiaremision_model->TransportistaListar();

        $guias = $this->documento_model->ListarGuias();

        $unidadmedida = $this->unidadmedida_model->Listar();

        switch ($_SESSION['usu_enterpriseRuc']) {
            case '20603942133':
                $habilitado = 1;
                break;
            case '20608420721':
                $habilitado = 1;
                break;
            case '20553754454':
                $habilitado = 1;
                break;
            default:
                break;
        }
        $empresas_obs = $habilitado;
        $observacion_vendedor = $habilitado = 1 ? 'onchange=asignarobs();' : '';

        $ptipomovimiento = null;
        $pbienes = null;
        $pobservacion = null;
        $ptipopago = null;
        // $ptipodocumento = null;

        foreach ($parametro as $r) {
            if ($r->__GET('Parametro_Id') == 3) {
                $ptipomovimiento = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 4) {
                $pbienes = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 5) {
                $pobservacion = $r->__GET('sParValor');
            } else if ($r->__GET('Parametro_Id') == 7) {
                $ptipopago = $r->__GET('sParValor');
            }
        }

        $script = '';

        $movimiento = $this->movimiento_model->Buscar($_POST['Movimiento_Id'])[0];
        //print_r($movimiento);die();

        $detalle_movimiento = $this->movimientodetalle_model->Buscar($movimiento->__GET('Movimiento_Id'));
        //print_r($detalle_movimiento);
        if (!empty($detalle_movimiento)) {
            foreach ($detalle_movimiento as $dc) {
                $um = $this->unidadmedida_model->Buscar($dc->nMovDetUnidad_Id)[0];

                $Unidadmedida_Id = $dc->nMovDetUnidad_Id;
                $sUndalias = $um->sUndDescripcion;
                $codigosunat = $um->sUndCodeSunat;
                $sMovDetConCantidad = (float)$dc->nMovDetCantidad;
                $nMovDetConPrecioUnitario = (float)$dc->nMovDetPrecioLista;
                $sProNombre = $dc->sProSrvNombre;

                $script .= sprintf(
                    "<script>
                    products_detail.push({
                        Unidadmedida_Id: '%s',
                        sUndalias: '%s',
                        sUMeCodigoSunat: '%s',
                        nTDeCantidad: %s,
                        nTDeSubtotal: %s * %s,
                        nTDePrecio: %s,
                        nTDeIGV: 0,
                        sProNombre: '%s',
                        Producto_Id: %s,
                        nTDeEstadoIGV: 0,
                        nTDeBase: %s * %s
                    });
                    </script>",
                    $Unidadmedida_Id,
                    $sUndalias,
                    $codigosunat,
                    $sMovDetConCantidad,
                    $sMovDetConCantidad,
                    $nMovDetConPrecioUnitario,
                    $nMovDetConPrecioUnitario,
                    $sProNombre,
                    $dc->prodserv_Id,
                    $sMovDetConCantidad,
                    $nMovDetConPrecioUnitario
                );
            }
            $script .= '<script>create_table();</script>';
        }

        $mov = new guiaremision();
        // $mov->__SET('Movimiento_Id', '0');
        // $mov->__SET('nMovOrdenCompra_Id', '');
        // $mov->__SET('nro_decimales', '');
        // $mov->__SET('dMovFecha', date('d-m-Y'));
        // $mov->__SET('nMovTipoMovimiento_Id', 2); 
        // $mov->__SET('nMovTipopago', $movimiento->__get('nMovTipopago'));
        $mov->__SET('nMovTipoOrigenDestino', $movimiento->__get('nMovTipoOrigenDestino'));
        $mov->__set('nMovOrigenDestino_Id', $movimiento->__get('nMovOrigenDestino_Id'));
        //$mov->__set('sGuiOtroMotivo', 'Hola');
        // $mov->__SET('nMovTipodestino', $movimiento->__get('nMovTipodestino'));
        // $mov->__SET('Almacen_Id', $movimiento->__get('nMovTipodestino'));
        // $mov->__SET('Documento_Id', $ptipodocumento);
        $mov->__SET('sMovDocReferencia', str_replace(' ', '-', $movimiento->__get('Documento')));
        // $mov->__SET('nDocAfectoIGV', $movimiento->__get('nDocAfectoIGV'));
        // $mov->__SET('Moneda_Id', $movimiento->__get('Moneda_Id'));
        // $mov->__SET('nMovTipoCambio', $movimiento->__get('nMovTipoCambio'));
        // $mov->__SET('nMovImporte', $movimiento->__get('nMovImporte'));
        // $mov->__SET('nMovIGV', $movimiento->__get('nMovIGV'));
        // $mov->__SET('nMovTotal', $movimiento->__get('nMovTotal'));
        // $mov->__SET('nMovSaldo', $movimiento->__get('nMovSaldo'));
        // $mov->__SET('vendedor_id', $movimiento->__get('vendedor_id'));
        // $mov->__SET('dMovDetraccion', $movimiento->__get('dMovDetraccion'));
        // $mov->__SET('dMovPercepcion', $movimiento->__get('dMovPercepcion'));
        // $mov->__SET('dMovRetencion', $movimiento->__get('dMovRetencion'));
        // $mov->__SET('sMovObservacion', $movimiento->__get('sMovObservacion'));
        $mov->__SET('sTraCodigoMotivoTraslado', "14|VENTA SUJETA A CONFIRMACION DEL COMPRADOR");
        $r = $mov;

        // var_dump($r);

        // $promovido = true;
        // $promovido_fecha_credito = '';
        // $promovido_importe = 0;
        $promovido = true;



        require_once 'view/webforms/wfaguiaremisiona.php';

        echo $script;
    }

    function TransportistaAgregar()
    {
        $t = new stdClass();
        $t->sTraRUC = $_POST['sTraRUC'];
        $t->sTraNombre = $_POST['sTraNombre'];
        $t->nTraEstado = 1;
        $t->nTraEliminado = 0;
        $t->Usuario_Id = $_SESSION['usu_codigo'];

        $Transportista_Id = $this->guiaremision_model->TransportistaGuardar($t);

        if (!empty($Transportista_Id)) {
            echo 'Exito';
        }
    }

    function TransportistaListar()
    {
        $list = $this->guiaremision_model->TransportistaListar();
        $rs = '<option value="" data-name="">- seleccionar -</option>';
        if (!empty($list)) {
            foreach ($list as $l) {
                $rs .= sprintf('<option value="%s" data-name="%s" data-ruc="%s">%s - %s</option>' . "\n", $l->Transportista_Id, $l->sTraNombre, $l->sTraRUC, $l->sTraRUC, $l->sTraNombre);
            }
        }
        echo $rs;
    }

    function VehiculoListar()
    {
        $list = $this->guiaremision_model->VehiculoListar($_POST['Transportista_Id']);
        $rs = '';
        if (!empty($list)) {
            foreach ($list as $l) {
                $rs .= sprintf('<option value="%s">', $l->sVehPlaca);
            }
        }
        echo $rs;
    }

    function ConductorListar()
    {
        $list = $this->guiaremision_model->ConductorListar($_POST['sVehPlaca']);
        $rs = '';
        if (!empty($list)) {
            foreach ($list as $l) {
                $rs .= sprintf('<option value="%s">', $l->sConDNI);
            }
        }
        echo $rs;
    }

    function DireccionesListar()
    {
        $listadirecciones = $this->origendestino_direcciones_model->ListarDirecciones($_POST['Provclien_Id']);
        $rs = '';
        if (!empty($listadirecciones)) {
            $rs = "<option value =''>Seleccione dirección</option>\n";
            foreach ($listadirecciones as $d) {
                $rs .= sprintf(
                    '<option val="%s" data-dept="%s" data-prov="%s" data-dist="%s">%s - %s</option>',
                    $d->sODDDireccion,
                    $d->sODDDepId,
                    $d->sODDProvId,
                    $d->sODDDistId,
                    $d->sODDDescripcion,
                    $d->sODDDireccion
                );
            }
        }
        echo $rs;
    }
}
