<?php
header('Access-Control-Allow-Origin: *');
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/prodserv.entidad.php';
require_once 'model/formula.model.php';
require_once 'model/formula.entidad.php';
require_once 'model/formuladetalle.model.php';
require_once 'model/formuladetalle.entidad.php';
require_once 'model/produccion.model.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/unidadmedida.model.php';


class ProduccionController
{
    private $parametro_model;
    private $prodserv_model;
    private $formula_model;
    private $formuladetalle_model;
    private $segurdidad;
    private $produccion;
    private $movimiento_model;
    private $documento;
    private $unidad;
    private $movimientodetalle_model;

    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->prodserv_model = new ProdservModel();
        $this->formula_model = new FormulaModel();
        $this->formuladetalle_model = new FormulaDetalleModel();
        $this->seguridad = new Seguridad();
        $this->produccion = new ProduccionModel();
        $this->movimiento_model = new MovimientoModel();
        $this->documento = new DocumentoModel();
        $this->unidad = new UnidadmedidaModel();
        $this->movimientodetalle_model = new MovimientoDetalleModel();
    }

    public function Index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $producciones = $this->produccion->ListarProduccion(
            isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio'])) : date('Y-m-d', strtotime('-1 day', strtotime(date('Y-m-d')))),
            isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin'])) : date('Y-m-d', strtotime(date('Y-m-d')))
        );
        require_once 'view/header.php';
        require_once 'view/webforms/wfaproduccion.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    function mostrarProduccion()
    {
        $datos = $this->produccion->BuscarProduccion($_POST['produccion_id']);
        $data = array();
        $parametro = $this->parametro_model->ListarParametros();

        $decimales = isset($parametro[13]->sParValor) ? $parametro[13]->sParValor : 2;

        foreach ($datos as $r) :
            echo "<tr>";
            echo "<td>Numero: </td>";
            echo "<td>" . $r->nProdNumero . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Fecha: </td>";
            echo "<td>" . date('Y-m-d', strtotime($r->nProdFecha_Act)) . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Producto Resultante: </td>";
            echo "<td>" . $r->sProSrvNombre . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Cantidad Producida: </td>";
            echo "<td>" . $r->nProdCantProducir . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Unidad de Medida: </td>";
            echo "<td>" . $r->sUndAlias . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Formula: </td>";
            echo "<td>" . $r->sForNombre . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Decripción:</td>";
            echo "<td>"  . $r->sForDescripcion . " </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Estado</td>";
            echo "<td>" . ($r->nProdEstado == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label label-danger">Anulado</span>') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Unidad de Medida</th>";
            echo "<th>Lote</th>";
            echo "<th>Costo</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";

            $detalle_produccion = $this->produccion->BuscarProduccionDetalle($_POST['produccion_id']);

            if (count($detalle_produccion) > 0) {
                foreach ($detalle_produccion as $detalle_prod) :
                    echo '<tr>';
                    echo '<td>' . $this->produccion->obtenerLotexId($detalle_prod->nProdDetLoteId)->sProSrvNombre . '</td>';
                    echo '<td>' . $detalle_prod->nProdDetCantidad  . '</td>';
                    echo '<td>' . $this->formuladetalle_model->ObtenerMedidaXId($this->produccion->obtenerLotexId($detalle_prod->nProdDetLoteId)->nProSrvUnidad_Id)->sUndAlias . '</td>';
                    echo '<td>' . $this->produccion->obtenerLotexId($detalle_prod->nProdDetLoteId)->sProLNombreLote  . '</td>';
                    echo '<td>' . number_format($this->produccion->obtenerLotexId($detalle_prod->nProdDetLoteId)->nProLPrecioL, $decimales) . '</td>';
                endforeach;
            } else {
                echo '<tr>';
                echo '<td colspan="5">No se encontraron registros</td>';
                echo '</tr>';
            }
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }


    public function EliminarFormula()
    {
        $for = new formula();
        $for->__SET('formula_Id', $_POST['IdFor']);
        $this->formula_model->Eliminar($for);
        echo '<script type="text/javascript">window.location="?c=Formula&a=Index";</script>';
    }

    //TODO MODIFIQUE
    public function FrmGuardarProduccion()

    {
        $productos = $this->prodserv_model->listarProductosProductoLote();
        $formulas = $this->formula_model->Listar();

        require_once 'view/webforms/wfaproducciona.php';
    }
    public function GuardarFormula()
    {
        $detalle_for = json_decode($_POST['detalle']);

        $for = new formula();
        if ($_POST['formula_Id'] != 0 ? $for->__SET('formula_Id', $_POST['formula_Id']) : '');

        $for->__SET('sForNombre', $_POST['sForNombre']);
        $for->__SET('dForFecha', $_POST['dForFecha']);
        $for->__SET('nForProdResultante', $_POST['nForProdResultante']);
        $for->__SET('sForDescripcion', $_POST['sForDescripcion']);
        $for->__SET('nForEstado', $_POST['nForEstado']);
        $for->__SET('nForEliminado', 0);
        $for->__SET('nForUsuario_Id', $_SESSION['usu_codigo']);

        if ($_POST['formula_Id'] != 0) {
            $this->formula_model->Editar($for);
        } else {
            $formula = $this->formula_model->Crear($for);
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                    </div>';
        }

        $detalle_for_cantidad = count($detalle_for);

        for ($i = 0; $i < $detalle_for_cantidad; $i++) {

            $fordet = new formuladetalle();
            if ($detalle_for[$i]->idDetFor != 0 ? $for->__SET('formuladetalle_Id', $detalle_for[$i]->idDetFor) : '');

            $fordet->__SET('formula_Id', isset($formula) ? $formula : $_POST['formula_Id']);
            $fordet->__SET('nForDetProducto', $detalle_for[$i]->nForDetProducto);
            $fordet->__SET('nForDetKg', $detalle_for[$i]->nForDetKg);
            $fordet->__SET('sForDescripcion', $_POST['sForDescripcion']);
            $fordet->__SET('nForEstado', $_POST['nForEstado']);
            $fordet->__SET('nForEliminado', 0);
            $fordet->__SET('nForUsuario_Id', $_SESSION['usu_codigo']);

            if ($detalle_for[$i]->idDetFor != 0) {
                $this->formuladetalle_model->EditarDetalleFormula($fordet);
            } else {
                $this->formuladetalle_model->GuadarDetalleFormula($fordet);
            }
        }
    }


    public function FrmEditarProduccion()
    {

        $datos = $this->produccion->BuscarProduccion($_POST['produccion_id']);

        $formulas = $this->formula_model->Listar();
        $detalle_produccion = $this->formula_model->obtenerFormulaPorId($datos[0]->nProdFormulaId);
        $formula_Id = $datos[0]->nProdFormulaId;
        $productos = $this->prodserv_model->listarProductosProductoLote();
        $editar = true;
        $cantidadProducir = $datos[0]->nProdCantProducir;
        $idproduccion =  $_POST['produccion_id'];

        foreach ($detalle_produccion as $dp) :
            require_once 'view/webforms/wfaproducciona.php';
        endforeach;
    }

    public function mostrarFormula()
    {
        $datos = $this->formula_model->Buscar($_POST['formula_Id']);
        $data = array();
        foreach ($datos as $r) :
            echo "<tr>";
            echo "<td>Nombre fórmula: </td>";
            echo "<td>" . $r->__GET('sForNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Fecha: </td>";
            echo "<td>" . $r->__GET('dForFecha') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Producto resultante: </td>";
            echo "<td>" . $r->__GET('sProSrvNombre') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Decripción:</td>";
            echo "<td>"  . $r->__GET('sForDescripcion') . " </td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>Estado</td>";
            echo "<td>" . ($r->__GET('nForEstado') == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label bg-danger">Inhabilitado</span>') . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Kg</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_formula = $this->formuladetalle_model->ListarDetalle($_POST['formula_Id']);
            foreach ($detalle_formula as $detmov) :
                echo '<tr>';
                echo '<td>' . $detmov->sProSrvNombre . '</td>';
                echo '<td>' . $detmov->nForDetKg . '</td>';
            endforeach;
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>';
        endforeach;
        echo '</table>';
    }
    public function EliminarProduccion()
    {
        $idmov_ingreso = $_POST['movimiento_id'];
        $idproduccion = $_POST['produccion_id'];


        //Verificar si tiene el mismo stock en el producto lote ingresado del producto resultante
        //obtener el movimiento de ingreso con su cantidad
        $movimiento = $this->produccion->obtenerMovimientoxId($idmov_ingreso);

        $stockMovimiento = $movimiento->stockMovimientoIngreso;

        //obtener el lote 
        $stockLote =   $movimiento->stockLote;

        //verficar si tienen el mismo stock
        if ($stockMovimiento != $stockLote) {
            echo '{"ok":"0","mensaje":"No se puede anular la producción"}';
        } else {
            //Tienen mismo stock

            //en cabezera es idmovimiento ingreso
            $row = $this->produccion->EliminarProduccion($idmov_ingreso, $_SESSION['usu_codigo']);

            //en detalle es idmovimiento salida
            $produccionDetalle = $this->produccion->BuscarProduccionDetalle($idproduccion);
            $idmov_salida = count($produccionDetalle) > 0 ? $produccionDetalle[0]->nProdDetMovId : 0;

            $row2 = $this->produccion->EliminarProduccion($idmov_salida, $_SESSION['usu_codigo']);

            //Cambiar estado de produccion a anulado
            $row3 = $this->produccion->cambiarEstado($idproduccion);

            if ($row > 0 && $row2 > 0 && $row3 > 0) {
                echo '{"ok":"1","mensaje":"Producción anulada correctamente."}';
            } else {
                echo '{"ok":"0","mensaje":"Error al anular la producción."}';
            }
        }
    }

    public function calcularToneladas()
    {

        $id = $_POST['id'];

        $datos = $this->formula_model->obtenerFormulaPorId($id);

        echo json_encode($datos);
    }

    public function guardarProduccion()
    {
        $datos = json_decode($_POST['detalle']);
        $tam = $_POST['tam'];
        $nProdNumero = $_POST['nProdNumero'];
        $formula_Id = $_POST['formula_Id'];
        $nProdCantProducir = $_POST['nProdCantProducir'];
        $nProdMovId = $_POST['nProdMovId'];
        $nProdUsuario_Id = $_SESSION['usu_codigo'];
        $nProdFecha_Act = date('Y-m-d H:i:s');
        $nProdEstado = '1';
        $nProdEliminado = '0';
        $precioSalida = 0;

        //Guardar en movimiento TIPO SALIDA
        //Obtener el correlativo del Documento para salida
        $correlativoSalida = $this->documento->Numero(10);

        //GUARDAR MOVIMIENTO
        $mov = new Movimiento();
        $mov->__SET('dMovFecha', date('Y-m-d')); //ESTA
        $mov->__SET('nMovTipoMovimiento_Id', 4); //ES SALIDA;
        $mov->__SET('nMovTipopago', 1); //ESTA CONTADO
        $mov->__SET('Almacen_Id', $datos[0]->Almacen_Id); //ESTA
        $mov->__SET('nMovTipoOrigenDestino', 2); //ESTA CLIENTE;
        $mov->__SET('nMovOrigenDestino_Id', 12); //ESTA cliente//!ESTO ESTA ESTICO SE NECESITA CAMBIAR
        $mov->__SET('nMovTipodestino', 1);
        $mov->__SET('Documento_Id', $correlativoSalida->Documento_Id);
        $mov->__SET('sMovDocumento', $correlativoSalida->sDocSiguiente); //CORRELATIVO de la DB
        $mov->__SET('sMovDocReferencia', '');
        $mov->__SET('Moneda_Id', $datos[0]->nProLMonedaCompra_Id); //ESTA
        $mov->__SET('nMovTipoCambio', 0);
        $mov->__SET('nMovImporte',  $_POST['dMovImporte']); //suma de las cantidades
        $mov->__SET('nMovIGV', $_POST['dMovIGV']); // 18% del improte
        $mov->__SET('nMovTotal',  $_POST['dMovTotal']); //suma del importe mas igv
        $mov->__SET('nMovSaldo', 0); //contado = 0
        $mov->__SET('nMovTotalCancelado',  0); //lo mismo al credito pero por el momento es al contado = 0
        $mov->__SET('dMovDetraccion', 0); //0
        $mov->__SET('dMovPercepcion', 0); //0
        $mov->__SET('dMovRetencion', 0); //0
        $mov->__SET('sMovObservacion', ''); //ESTA
        $mov->__SET('nMovEstado', 1); //ESTA;
        $mov->__SET('nMovEliminado', 0);
        $mov->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $mov->__SET('nMovVendedor_Id', 0); //vendedor no asginado
        $mov->__SET('dMovICBPER', 0); //0

        $Movimiento_Id = $this->movimiento_model->Guardar($mov);

        $mov->__SET('Movimiento_Id', $Movimiento_Id);
        $parametro = $this->parametro_model->ListarParametros();

        //Guardar detallle movimiento de salida
        for ($i = 0; $i < $tam; $i++) {
            $unidad = $this->unidad->ObtenerUnidadIdPorAlias($datos[$i]->unidad);
            $movdet = new Movimientodetalle();
            $movdet->__SET('Movimiento_Id', $Movimiento_Id);
            $movdet->__SET('TipoMovimiento_Id', '4'); //ES SALIDA
            $movdet->__SET('TipoDestino', '1');
            $movdet->__SET('ProdServ_Id', $datos[$i]->nProdDetProductoId);
            $movdet->__SET('Almacen_Id', $datos[$i]->Almacen_Id);
            $multlotes = null;

            foreach ($parametro as $r) {
                if ($r->__GET('Parametro_Id') == 13) {
                    $multlotes = $r->__GET('sParValor');
                }
            }
            // 2023/01/11/11/1507
            if ($multlotes) {
                $multlotes = explode('|', $multlotes);

                if ($multlotes[1]) {
                    $movdet->__SET('Lote', $datos[$i]->lote != 0 ? $datos[$i]->lote : date('Ymdhis'));
                } else {
                    $movdet->__SET('Lote', $datos[$i]->lote != 0 ? $datos[$i]->lote : '202001'); //un solo lote
                }
            }

            // $movdet->__SET('PLote', $datos[$i]->lote);
            $movdet->__SET('FechaVencimiento', ''); // pendiente
            $movdet->__SET('Cantidad', $datos[$i]->cantidadOriginal);
            $movdet->__SET('Unidad_Id', $unidad->UnidadMedida_Id); // pendiente
            $movdet->__SET('MonedaCompra_Id', $datos[$i]->nProLMonedaCompra_Id);
            $movdet->__SET('PrecioLista', $datos[$i]->costo); //precio del catalogo producto
            $movdet->__SET('Descuento', 0);
            $movdet->__SET('Precio', $datos[$i]->costo);
            $precioSalida += $datos[$i]->costo;
            $SubTotal = $datos[$i]->costo * $datos[$i]->cantidad;
            $movdet->__SET('SubTotal', $SubTotal);
            $movdet->__SET('Usuario_Id', $_SESSION['usu_codigo']);
            $movdet->__SET('TipoCambio', '0');
            $movdet->__SET('nMovDetIncluyeIgv', 0);
            $movdet->__SET('dMovDetICBPER', '0');
            $this->movimientodetalle_model->Guardar($movdet);
        }

        //Ingreso
        //!Obtener el correlativo del Documento para INGRESO
        $correlativoIngreso = $this->documento->Numero(8);
        //GUARDAR MOVIMIENTO de INGRESO
        $mov2 = new Movimiento();
        $mov2->__SET('dMovFecha', date('Y-m-d')); //ESTA
        $mov2->__SET('nMovTipoMovimiento_Id', 3); //ES INGRESO;
        $mov2->__SET('nMovTipopago', 1); //ESTA CONTADO
        $mov2->__SET('Almacen_Id', $correlativoIngreso->Almacen_Id); //ESTA
        $mov2->__SET('nMovTipoOrigenDestino', 2); //ESTA CLIENTE;
        $mov2->__SET('nMovOrigenDestino_Id', 12); //ESTA cliente //!esto esta 
        $mov2->__SET('nMovTipodestino', 1);
        $mov2->__SET('Documento_Id', $correlativoIngreso->Documento_Id);
        $mov2->__SET('sMovDocumento', $correlativoIngreso->sDocSiguiente); //CORRELATIVO de la DB
        $mov2->__SET('sMovDocReferencia', '');
        $mov2->__SET('Moneda_Id', 1); //SOLES
        $mov2->__SET('nMovTipoCambio', 0);
        $importeSalida = $precioSalida * ($nProdCantProducir); //Esta en toneladas pasar a KG
        $mov2->__SET('nMovImporte',  $importeSalida); //!suma de las cantidades
        $IGV = $importeSalida * 0.18;
        $mov2->__SET('nMovIGV', $IGV); // !18% del importe
        $mov2->__SET('nMovTotal',  $IGV + $importeSalida); //!suma del importe mas igv
        $mov2->__SET('nMovSaldo', 0); //contado = 0
        $mov2->__SET('nMovTotalCancelado',  0); //lo mismo al credito pero por el momento es al contado = 0
        $mov2->__SET('dMovDetraccion', 0); //0
        $mov2->__SET('dMovPercepcion', 0); //0
        $mov2->__SET('dMovRetencion', 0); //0
        $mov2->__SET('sMovObservacion', ''); //ESTA
        $mov2->__SET('nMovEstado', 1); //ESTA;
        $mov2->__SET('nMovEliminado', 0);
        $mov2->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $mov2->__SET('nMovVendedor_Id', 0); //vendedor no asginado
        $mov2->__SET('dMovICBPER', 0); //0

        $Movimiento_Id2 = $this->movimiento_model->Guardar($mov2);

        $mov2->__SET('Movimiento_Id', $Movimiento_Id2);

        //Guardar detallle movimiento de INGRESO
        $unidad2 = $this->unidad->ObtenerUnidadIdPorAlias($_POST['sUndAlias']);
        $movdet2 = new Movimientodetalle();
        $movdet2->__SET('Movimiento_Id', $Movimiento_Id2);
        $movdet2->__SET('TipoMovimiento_Id', 3); //ES INGRESO
        $movdet2->__SET('TipoDestino', 1);
        $movdet2->__SET('ProdServ_Id', $_POST['productoIdResultante']);
        $movdet2->__SET('Almacen_Id', $correlativoIngreso->Almacen_Id);
        $movdet2->__SET('Lote', date('Ymdhis')); //un solo lote y nuevo lote
        $fVencimientoNL = date('Y-m-d', strtotime('+2 year'));
        $movdet2->__SET('FechaVencimiento', $fVencimientoNL); // fecha vencimiento 2 años mas
        $movdet2->__SET('Cantidad', $nProdCantProducir);
        $movdet2->__SET('Unidad_Id', $unidad2->UnidadMedida_Id); // pendiente
        $movdet2->__SET('MonedaCompra_Id', '1');
        $movdet2->__SET('PrecioLista', $precioSalida); //precio del catalogo producto
        $movdet2->__SET('Descuento', 0);
        $movdet2->__SET('Precio', $precioSalida);
        $movdet2->__SET('SubTotal', $importeSalida);
        $movdet2->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $movdet2->__SET('TipoCambio', '0');
        $movdet2->__SET('nMovDetIncluyeIgv', 0);
        $movdet2->__SET('dMovDetICBPER', '0');
        $this->movimientodetalle_model->Guardar($movdet2);


        //Guardar produccion
        //en cabezera es idmovimiento ingreso
        $this->produccion->guardarProduccion($nProdNumero, $formula_Id, $nProdCantProducir, $Movimiento_Id2, $nProdUsuario_Id, $nProdFecha_Act, $nProdEstado, $nProdEliminado);

        $produccion_id = $this->produccion->obtenerUltimoIdProduccion();

        ///Guardar detalle de produccion es idmovimiento salida
        for ($i = 0; $i < $tam; $i++) {
            $produccion_id = $produccion_id;
            $nProdDetProductoId = $datos[$i]->nProdDetProductoId;
            $nProdDetCantidad = $datos[$i]->kg;
            $nProdDetLoteId = $datos[$i]->nProdDetLoteId;
            $nProdDetMovId = $Movimiento_Id;
            $this->produccion->guardarDetalleProduccion($produccion_id, $nProdDetProductoId, $nProdDetCantidad, $nProdDetLoteId, $nProdDetMovId);
        }

        if ($Movimiento_Id2 && $Movimiento_Id) {
            echo 'true';
        } else {
            echo 'false';
        }
    }
}
