<?php
class FormulaModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL formula_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $for = new formula();
                $for->__SET('formula_Id', $r->formula_Id);
                $for->__SET('sForNombre', $r->sForNombre);
                $for->__SET('dForFecha', date('d-m-Y', strtotime($r->dForFecha)));
                $for->__SET('nForProdResultante', $r->nForProdResultante);
                $for->__SET('sProSrvNombre', $r->sProSrvNombre);
                $for->__SET('sForDescripcion', $r->sForDescripcion);
                $for->__SET('nForEstado', $r->nForEstado);
                $for->__SET('nForEliminado', $r->nForEliminado);
                $for->__SET('dForFecha_Act', $r->dForFecha_Act);
                $for->__SET('nForUsuario_Id', $r->nForUsuario_Id);
                $for->__SET('sUndAlias', $r->sUndAlias);
                $result[] = $for;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($formula_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL formula_listar($formula_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $for = new formula();
                $for->__SET('formula_Id', $r->formula_Id);
                $for->__SET('sForNombre', $r->sForNombre);
                $for->__SET('dForFecha', date('d-m-Y', strtotime($r->dForFecha)));
                $for->__SET('nForProdResultante', $r->nForProdResultante);
                $for->__SET('sProSrvNombre', $r->sProSrvNombre);
                $for->__SET('sForDescripcion', $r->sForDescripcion);
                $for->__SET('nForEstado', $r->nForEstado);
                $for->__SET('nForEliminado', $r->nForEliminado);
                $for->__SET('dForFecha_Act', $r->dForFecha_Act);
                $for->__SET('nForUsuario_Id', $r->nForUsuario_Id);

                $result[] = $for;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Crear(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_crear(?,?,?,?,?,?,?, @formula_Id)");
            $stm->execute(array(
                $data->__get('sForNombre'),
                date('Y-m-d', strtotime($data->__get('dForFecha'))),
                $data->__get('nForProdResultante'),
                $data->__get('sForDescripcion'),
                $data->__get('nForEstado'),
                $data->__get('nForEliminado'),
                $data->__get('nForUsuario_Id'),

            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                return $r->formula_Id;
            }
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_editar(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('formula_Id'),
                $data->__get('sForNombre'),
                date('Y-m-d', strtotime($data->__get('dForFecha'))),
                $data->__get('nForProdResultante'),
                $data->__get('sForDescripcion'),
                $data->__get('nForEstado'),
                $data->__get('nForEliminado'),
                $data->__get('nForUsuario_Id'),

            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Formula&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_eliminar(?)");
            $stm->execute(array($data->__get('formula_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function obtenerFormulaPorId($id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL obtenerFormulaPorId(?)");
            $stm->execute([$id]);

            $i = 0;

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[$i]['formula_Id'] = $r->formula_Id;
                $result[$i]['sForNombre'] = $r->sForNombre;
                $result[$i]['dForFecha'] = $r->dForFecha;
                $result[$i]['formuladetalle_Id'] = $r->formuladetalle_Id;
                $result[$i]['nForDetCantidad'] = $r->nForDetCantidad;
                $result[$i]['nForDetProducto'] = $r->nForDetProducto;
                $result[$i]['nForDetUM_Id'] = $r->nForDetUM_Id;
                $result[$i]['sProSrvNombre'] = $r->sProSrvNombre;
                $result[$i]['sProSrvNombreComercial'] = $r->sProSrvNombreComercial;
                $result[$i]['sProLNombreLote'] = $r->sProLNombreLote;
                $result[$i]['nProLPrecioL'] = $r->nProLPrecioL;
                $result[$i]['nProLStockReal'] = $r->nProLStockReal;
                $result[$i]['ProdServ_Id'] = $r->ProdServ_Id;
                $result[$i]['ProductoLote_Id'] = $r->ProductoLote_Id;
                $result[$i]['nProLMonedaCompra_Id'] = $r->nProLMonedaCompra_Id;
                $result[$i]['Almacen_Id'] = $r->Almacen_Id;
                $result[$i]['sUndDescripcion'] = $r->sUndDescripcion;
                $result[$i]['sUndAlias'] = $r->sUndAlias;
                $i++;
            }

            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
