<?php
class FormulaDetalleModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function GuadarDetalleFormula(formuladetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formuladet_crear(?,?,?)");
            $stm->execute(array(
                $data->__get('formula_Id'),
                $data->__get('nForDetProducto'),
                $data->__get('nForDetKg')

            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                return $r->formuladetalle_Id;
            }
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function GuadarDetalleFormula2(formuladetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formuladet_crear(?,?,?,?)");
            $stm->execute(array(
                $data->__get('formula_Id'),
                $data->__get('nForDetProducto'),
                $data->__get('nForDetCantidad'),
                $data->__get('nForDetUM_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EditarDetalleFormula(formuladetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formuladet_editar(?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('formuladetalle_Id'),
                $data->__get('formula_Id'),
                $data->__get('nForDetProducto'),
                $data->__get('nForDetCantidad'),
                $data->__get('nForDetUM_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarProductoDetalleFormula($id)
    {
        try {
            $stm = $this->pdo->prepare("DELETE FROM formuladetalle WHERE formuladetalle_Id = ?");
            $stm->execute(array($id));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarDetalleFormula($id)
    {
        try {
            $stm = $this->pdo->prepare("CALL formuladet_eliminar(?)");
            $stm->execute(array($id));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListarDetalle($formula_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL listar_detalle_formulas(?)');
            $stm->execute([$formula_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ObtenerMedidaXId($id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ObtenerUnidadXId(?)');
            $stm->execute([$id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = $r;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
}
