<?php

class GuiaremisionModel extends Database
{
    private $pdo;
    private $conexion;
    private $table = 'guiaremision';
    function __CONSTRUCT()
    {
        try {
            $this->conexion = $this->cnn();
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        $this->conexion->where('g.nGuiEliminado', 0);
        $this->conexion->join("documento d", "d.sDocCodigoSunat=g.TipoDocumento_Id", "LEFT");
        return $this->conexion->arraybuilder()->get($this->table . ' g', null, 'g.*, d.sDocNombreCorto');
    }

    public function Guia_listardate($fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL gui_listdate('" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new guiaremision();
                $usu->__SET('Guiaremision_Id', $r->Guiaremision_Id);
                $usu->__SET('dTraFecha', $r->dTraFecha);
                $usu->__SET('dTraFechaTraslado', $r->dTraFechaTraslado);
                $usu->__SET('sTraSerie', $r->sTraSerie);
                $usu->__SET('sTraNumero', $r->sTraNumero);
                $usu->__SET('sSerieNumeroRelacionado', $r->sSerieNumeroRelacionado);
                $usu->__SET('sCliente', $r->sCliente);
                $usu->__SET('Moneda_Id', $r->Moneda_Id);
                $usu->__SET('nGuiEstado', $r->nGuiEstado);
                $usu->__SET('nGuiEstadoSunat', $r->nGuiEstadoSunat);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($id)
    {
        $this->conexion->where("Guiaremision_Id", $id);
        return $this->conexion->getOne($this->table);
    }

    public function Crear($data)
    {

        $v = new stdClass();
        $v->sTraRUC = $data['sTraRUCTransportistaTraslado'];
        $v->sVehPlaca = $data['sTraPlacaVehiculoTraslado'];
        $v->Usuario_Id = $_SESSION['usu_codigo'];
        $Vehiculo_Id = $this->VehiculoAgregar($v);

        $c = new stdClass();
        $c->nConVehiculo_Id = $Vehiculo_Id;
        $c->sConDNI = $data['sTraDNIConductorTraslado'];
        $c->Usuario_Id = $_SESSION['usu_codigo'];
        $Conductor_Id = $this->ConductorAgregar($c);


        $cliente = $this->getClientesById($data['nMovOrigenDestino_Id']);
        //TODO ver si esta bien el sin direccion
        return $this->conexion->insert($this->table, [
            //Guiaremision_Id 
            'TipoDocumento_Id' => 7,
            'sNumeroGenerado' => substr($data['sNumeroGenerado'], 5),
            'Moneda_Id' => $data['Moneda_Id'],
            //nTraEsGratuito
            //nTraSubTotalSinIGV
            //nTraEsAnticipo
            //nTraTieneDetraccion
            //nTraMontoDetraccion
            //nTraPctjDetraccion
            //nTraImporteTotal
            'dTraFecha' => date('Y-m-d', strtotime($data['dTraFecha'])),
            'sSerieNumeroRelacionado' => $data['sSerieNumeroRelacionado'],
            //nCReCodigoSunat
            //sCategoriaReclamo
            'sCliNroIdentidad' => isset($cliente) ? $cliente['sODRucDni'] : '',
            'sCliDomicilioFiscal' => isset($cliente) ? $cliente['sODDireccion'] : '',
            // 'sCliUbigeoNombre' => isset($cliente) ? $cliente['nProcliDepId'] . '' . $cliente['nProcliProvId'] . '' . $cliente['nProcliDistId'] : '',
            'sCliUbigeoNombre' => isset($cliente) ? $cliente['nProcliDepName'] . ' ' . $cliente['nProcliProvName'] . ' ' . $cliente['nProcliDistName'] : '',
            'sCliEmail' => isset($cliente) ? $cliente['sODCorreo'] : '',
            'sCliPaisBreve' => 'PE',
            'sCliente' => isset($cliente) ? $cliente['sODNombreComercial'] : '',
            'nMovOrigenDestino_Id' => $data['nMovOrigenDestino_Id'],
            //nTraMontoIGV
            'sTraSerie' => explode('-', $data['sNumeroGenerado'])[0],
            'sTraNumero' => explode('-', $data['sNumeroGenerado'])[1],
            'sTraRUCEmpresa' => $_SESSION['usu_enterpriseRuc'],
            'nTipoDocRelacionado' => $data['nTipoDocRelacionado'],
            'sTraCodigoMotivoTraslado' => explode('|', $data['sTraCodigoMotivoTraslado'])[0],
            'sTraMotivoTraslado' => explode('|', $data['sTraCodigoMotivoTraslado'])[1],
            'sTraCodigoUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[0],
            'sTraAliasUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[1],
            'sTraDescripcionUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[2],
            'nTraPesoBrutoGuiaTraslado' => $data['nTraPesoBrutoGuiaTraslado'],
            'sTraCodigoModalidadTraslado' => explode('|', $data['sTraCodigoModalidadTraslado'])[0],
            'sTraDescripcionModalidadTraslado' => explode('|', $data['sTraCodigoModalidadTraslado'])[1],
            'dTraFechaTraslado' => date('Y-m-d', strtotime($data['dTraFechaTraslado'])),
            'sTraRUCTransportistaTraslado' => $data['sTraRUCTransportistaTraslado'],
            'sTraNombreTransportistaTraslado' => $data['sTraNombreTransportistaTraslado'],
            'sTraPlacaVehiculoTraslado' => $data['sTraPlacaVehiculoTraslado'],
            'sTraDNIConductorTraslado' => $data['sTraDNIConductorTraslado'],
            'sTraCodigoUbigeoPuntoLlegadaTraslado' => $data['dTraLleDepartamento'] . '' . $data['sTraLleProvincia'] . '' . $data['sTraLleDistrito'],
            'sTraDireccionPuntoLlegadaTraslado' => isset($data['sTraDireccionPuntoLlegadaTraslado']) ? $data['sTraDireccionPuntoLlegadaTraslado'] : '',
            'sTraCodigoUbigeoPuntoPartidaTraslado' => $data['dTraParDepartamento'] . '' . $data['sTraParProvincia'] . '' . $data['sTraParDistrito'],
            'sTraDireccionPuntoPartidaTraslado' => $data['sTraDireccionPuntoPartidaTraslado'],
            'Almacen_Id' => $data['Almacen_Id'],
            'sGuiObservacion' => $data['sGuiObservacion'],
            'dGuiFecha_Act' => date('Y-m-d H:i:s'),
            'Usuario_Id' => $_SESSION['usu_codigo'],
            'sGuiOtroMotivo' => $data['sGuiOtroMotivo']
        ]);
    }

    public function Update($id, $data)
    {
        $this->conexion->where('Guiaremision_Id', $id);
        $this->conexion->update($this->table, [
            'sNumeroGenerado' => substr($data['sNumeroGenerado'], 5),
            'Moneda_Id' => $data['Moneda_Id'],
            'dTraFecha' => date('Y-m-d', strtotime($data['dTraFecha'])),
            'sSerieNumeroRelacionado' => $data['sSerieNumeroRelacionado'],
            'sCliNroIdentidad' => isset($cliente) ? $cliente['sODRucDni'] : '',
            'sCliDomicilioFiscal' => isset($cliente) ? $cliente['sODDireccion'] : '',
            'sCliUbigeoNombre' => isset($cliente) ? $cliente['nProcliDepId'] . '' . $cliente['nProcliProvId'] . '' . $cliente['nProcliDistId'] : '',
            'sCliEmail' => isset($cliente) ? $cliente['sODCorreo'] : '',
            'sCliPaisBreve' => 'PE',
            'sCliente' => isset($cliente) ? $cliente['sODNombreComercial'] : '',
            'nMovOrigenDestino_Id' => $data['nMovOrigenDestino_Id'],
            'sTraSerie' => explode('-', $data['sNumeroGenerado'])[0],
            'sTraNumero' => explode('-', $data['sNumeroGenerado'])[1],
            'sTraRUCEmpresa' => $_SESSION['usu_enterpriseRuc'],
            'nTipoDocRelacionado' => $data['nTipoDocRelacionado'],
            'sTraCodigoMotivoTraslado' => explode('|', $data['sTraCodigoMotivoTraslado'])[0],
            'sTraMotivoTraslado' => explode('|', $data['sTraCodigoMotivoTraslado'])[1],
            'sTraCodigoUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[0],
            'sTraAliasUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[1],
            'sTraDescripcionUnidadMedidaTraslado' => explode('|', $data['sTraCodigoUnidadMedidaTraslado'])[2],
            'nTraPesoBrutoGuiaTraslado' => $data['nTraPesoBrutoGuiaTraslado'],
            'sTraCodigoModalidadTraslado' => explode('|', $data['sTraCodigoModalidadTraslado'])[0],
            'sTraDescripcionModalidadTraslado' => explode('|', $data['sTraCodigoModalidadTraslado'])[1],
            'dTraFechaTraslado' => date('Y-m-d', strtotime($data['dTraFechaTraslado'])),
            'sTraRUCTransportistaTraslado' => $data['sTraRUCTransportistaTraslado'],
            'sTraNombreTransportistaTraslado' => $data['sTraNombreTransportistaTraslado'],
            'sTraPlacaVehiculoTraslado' => $data['sTraPlacaVehiculoTraslado'],
            'sTraDNIConductorTraslado' => $data['sTraDNIConductorTraslado'],
            'sTraCodigoUbigeoPuntoLlegadaTraslado' => $data['dTraLleDepartamento'] . '' . $data['sTraLleProvincia'] . '' . $data['sTraLleDistrito'],
            'sTraDireccionPuntoLlegadaTraslado' => $data['sTraDireccionPuntoLlegadaTraslado'],
            'sTraCodigoUbigeoPuntoPartidaTraslado' => $data['dTraParDepartamento'] . '' . $data['sTraParProvincia'] . '' . $data['sTraParDistrito'],
            'sTraDireccionPuntoPartidaTraslado' => $data['sTraDireccionPuntoPartidaTraslado'],
            'Almacen_Id' => $data['Almacen_Id'],
            'sGuiObservacion' => $data['sGuiObservacion'],
            'dGuiFecha_Act' => date('Y-m-d H:i:s'),
            'Usuario_Id' => $_SESSION['usu_codigo']
        ]);
    }

    public function updaeteEstado($id, $estado)
    {
        $this->conexion->where('Guiaremision_Id', $id);
        $this->conexion->update($this->table, ['nGuiEstadoSunat' => $estado]);
    }

    public function ELiminar($id)
    {
        $this->conexion->where('Guiaremision_Id', $id);
        $this->conexion->update($this->table, ['nGuiEliminado' => 1]);
    }

    public function getClientesById($cliente_id)
    {
        $this->conexion->where('OrigenDestino_Id', $cliente_id);
        return $this->conexion->getOne('origendestino');
    }

    public function VehiculoAgregar(stdClass $data)
    {
        try {
            $Vehiculo_Id = 0;
            $stm = $this->pdo->prepare("CALL veh_agregar(?,?,?)");
            $stm->execute(array(
                $data->sTraRUC,
                $data->sVehPlaca,
                $data->Usuario_Id
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Vehiculo_Id = $r->Vehiculo_Id;
            }
            //            echo "Se guardo correctamente ->".$nMovTipoMovimiento_Id;
            return $Vehiculo_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function ConductorAgregar(stdClass $data)
    {
        try {
            $Conductor_Id = 0;
            $stm = $this->pdo->prepare("CALL con_agregar(?,?,?)");
            $stm->execute(array(
                $data->nConVehiculo_Id,
                $data->sConDNI,
                $data->Usuario_Id
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Conductor_Id = $r->Conductor_Id;
            }
            //            echo "Se guardo correctamente ->".$nMovTipoMovimiento_Id;
            return $Conductor_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function TransportistaGuardar(stdClass $data)
    {
        try {
            $Transportista_Id = 0;
            $stm = $this->pdo->prepare("CALL tra_crear(?,?,?,?,?)");
            $stm->execute(array(
                $data->sTraRUC,
                $data->sTraNombre,
                $data->nTraEstado,
                $data->nTraEliminado,
                $data->Usuario_Id
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Transportista_Id = $r->Transportista_Id;
            }
            //            echo "Se guardo correctamente ->".$nMovTipoMovimiento_Id;
            return $Transportista_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function TransportistaListar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tra_listar(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function VehiculoListar($Transportista_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL veh_listar(?)");
            $stm->execute([$Transportista_Id]);

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function ConductorListar($Vehiculo_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL con_listar(?)");
            $stm->execute([$Vehiculo_Id]);

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
