<?php
class ProduccionModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function ListarProduccion($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL listarProducciones(?,?)");
            $stm->execute([$fechaInicio, $fechaFin]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] =  $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function EliminarProduccion($idmovimiento, $idusuario)
    {
        try {
            $stm = $this->pdo->prepare("CALL Mov_Anular(?,?)");
            $stm->execute([$idmovimiento, $idusuario]);
            return $stm->rowCount();
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarProduccion($produccion_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mostrarProduccion(?)");
            $stm->execute([$produccion_id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] =  $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerProducoxFormula($formula_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ObtenerProducoxFormulaId(?)");
            $stm->execute([$formula_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result =  $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarProduccionDetalle($produccion_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL mostrarProduccionDetalle(?)");
            $stm->execute([$produccion_id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] =  $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function obtenerMovimientoxId($id)
    {
        try {
            $result  = [];
            $stm = $this->pdo->prepare("call obtenerMovimientoxId(?)");
            $stm->execute([$id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function obtenerLotexId($id)
    {
        try {
            $result  = [];
            $stm = $this->pdo->prepare("call obtenerLotexId(?)");
            $stm->execute([$id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function cambiarEstado($idproduccion)
    {
        try {
            $stm = $this->pdo->prepare("UPDATE produccion SET nProdEstado = 0 WHERE produccion_id = ?");
            $stm->execute([$idproduccion]);
            return $stm->rowCount();
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function buscarProduccionxId($produccion_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL obtenerProduccionxId(?)");
            $stm->execute([$produccion_id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] =  $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL formula_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $for = new formula();
                $for->__SET('formula_Id', $r->formula_Id);
                $for->__SET('sForNombre', $r->sForNombre);
                $for->__SET('dForFecha', date('d-m-Y', strtotime($r->dForFecha)));
                $for->__SET('nForProdResultante', $r->nForProdResultante);
                $for->__SET('sProSrvNombre', $r->sProSrvNombre);
                $for->__SET('sForDescripcion', $r->sForDescripcion);
                $for->__SET('nForEstado', $r->nForEstado);
                $for->__SET('nForEliminado', $r->nForEliminado);
                $for->__SET('dForFecha_Act', $r->dForFecha_Act);
                $for->__SET('nForUsuario_Id', $r->nForUsuario_Id);

                $result[] = $for;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($formula_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL formula_listar($formula_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $for = new formula();
                $for->__SET('formula_Id', $r->formula_Id);
                $for->__SET('sForNombre', $r->sForNombre);
                $for->__SET('dForFecha', date('d-m-Y', strtotime($r->dForFecha)));
                $for->__SET('nForProdResultante', $r->nForProdResultante);
                $for->__SET('sProSrvNombre', $r->sProSrvNombre);
                $for->__SET('sForDescripcion', $r->sForDescripcion);
                $for->__SET('nForEstado', $r->nForEstado);
                $for->__SET('nForEliminado', $r->nForEliminado);
                $for->__SET('dForFecha_Act', $r->dForFecha_Act);
                $for->__SET('nForUsuario_Id', $r->nForUsuario_Id);

                $result[] = $for;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Crear(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_crear(?,?,?,?,?,?,?, @formula_Id)");
            $stm->execute(array(
                $data->__get('sForNombre'),
                date('Y-m-d', strtotime($data->__get('dForFecha'))),
                $data->__get('nForProdResultante'),
                $data->__get('sForDescripcion'),
                $data->__get('nForEstado'),
                $data->__get('nForEliminado'),
                $data->__get('nForUsuario_Id'),

            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                return $r->formula_Id;
            }
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_editar(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('formula_Id'),
                $data->__get('sForNombre'),
                date('Y-m-d', strtotime($data->__get('dForFecha'))),
                $data->__get('nForProdResultante'),
                $data->__get('sForDescripcion'),
                $data->__get('nForEstado'),
                $data->__get('nForEliminado'),
                $data->__get('nForUsuario_Id'),

            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Formula&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(formula $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL formula_eliminar(?)");
            $stm->execute(array($data->__get('formula_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //TODO AGREGUE

    public function obtenerUltimoIdProduccion()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT max(produccion_id) as produccion_id FROM produccion;");
            $stm->execute();

            $i = 0;
            foreach ($stm->fetchAll(PDO::FETCH_ASSOC) as $r) {
                $result[$i]['produccion_id'] = $r['produccion_id'];
                $i++;
            }
            return json_decode($result[0]['produccion_id']);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function guardarProduccion($nProdNumero, $formula_Id, $nProdCantProducir, $nProdMovId, $nProdUsuario_Id, $nProdFecha_Act, $nProdEstado, $nProdEliminado)
    {
        try {
            $stm = $this->pdo->prepare("CALL insertarProductoEnProduccion(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $nProdNumero,
                $formula_Id,
                $nProdCantProducir,
                $nProdMovId,
                $nProdUsuario_Id,
                $nProdFecha_Act,
                $nProdEstado,
                $nProdEliminado,
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function guardarDetalleProduccion($produccion_id, $nProdDetProductoId, $nProdDetCantidad, $nProdDetLoteId, $nProdDetMovId)
    {
        try {
            $stm = $this->pdo->prepare("CALL insertarDetalleProduccion(?,?,?,?,?)");
            $stm->execute(array(
                $produccion_id,
                $nProdDetProductoId,
                $nProdDetCantidad,
                $nProdDetLoteId,
                $nProdDetMovId,
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
